function [hat_x,info] = alg_optimEckhart(y,M,x_0,x_errmax,eps)

[p n] = size(M);


% RH
y = y - M*x_0;
B = x_errmax*ones(n,1);
Rm = zeros(p,1);
Ry = ones(p,1);
R = Ry + Rm; 

x_hist = [];
iter = 0;
maxiter = 50; % 50 
stopcond = 0.0001;
% keyboard
gogogo = 1;
while gogogo
    iter = iter + 1;
    if mod(iter,10)==0
        disp(['optimization iteration ' num2str(iter) '/' num2str(maxiter)]);
    end

    
    cvx_begin quiet
        variable x_cvx(n,1)
        % J1
        j1 = y - M*x_cvx;
        
        % J2
        j2 = x_cvx;
        
        % J3
        D = (-2)*eye(n) + diag(ones(n-1,1),1) + diag(ones(n-1,1),-1);
        j3 = (D*x_cvx);
        
        minimize(j1'.*(1./R')*j1 + j2'.*(1./B')*j2 + eps*(j3'*j3))

    cvx_end
    hat_x = x_cvx + x_0;
    
    x_neg = 0;
    x_pos = 0;
    negcount = 0;
    for j=1:n
        if hat_x(j) < 0
            x_neg = x_neg + hat_x(j);
            negcount = negcount + 1;
        else
            x_pos = x_pos + hat_x(j);
            B(j) = min(sqrt(1.5)*B(j),x_errmax);
        end
    end
    
    % expansion of B
    if 1 
        sortx = sort(hat_x(hat_x<0));
        icutoff = max(1,min(negcount,floor(n/3)));
        if length(sortx) == 0 
            cutoff = 0;
        else
            cutoff = sortx(icutoff);
        end
    else
        cutoff = 0; 
    end
    for j=1:n
        if hat_x(j) < cutoff
            B(j) = B(j)/2;
        end
    end
    
    % stop condition
    if iter > maxiter
        gogogo = 0;
    else
        if abs(x_neg/x_pos) < stopcond
            gogogo = 0;
        end
    end
%     x_neg
%     x_pos
    x_hist = [x_hist abs(x_neg/x_pos)];
end



info.x_hist = x_hist;

end